#include <stdio.h>
#include <iostream>
#include <vector>

#include "MinBall.h"

#include <QFile>
#include <QTextStream>
#include <QStringList>
#include <QElapsedTimer>

int main(int argc, char *argv[])
{
    typedef std::vector<double> Vector3;
    std::vector<Vector3> pnts;
    if(argc < 2) return 0;

    QFile file( argv[1] );
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) return 0;

    QTextStream inF(&file);
    while( !inF.atEnd() ){
        QString line = inF.readLine();
        if(!line.size()) continue;
        Vector3 p;
        foreach(QString coord, line.split(" ", QString::SkipEmptyParts)) p.push_back(coord.toDouble());
        pnts.push_back(p);
    }

    //QElapsedTimer timer; timer.start();

    {
        std::vector< Seb::Point<double> > sebPoints = SebPoints<double,Vector3>(pnts);
        MinBall mb(3, sebPoints);

        // Get radius
        double radius = mb.radius();

        // Get center
        Vector3 center(3,0);
        MinBallCenter<Vector3>(mb, center);

        // Output fit to standard out
        std::cout << qPrintable( QString("%1\n").arg(radius) );
        std::cout << qPrintable( QString("%1 %2 %3\n").arg(center[0]).arg(center[1]).arg(center[2]) );
    }

    //printf("%d ms", timer.elapsed());

    return 0;
}

