#include <stdio.h>
#include <iostream>

#include "MinOBB.h"

#include <QFile>
#include <QTextStream>
#include <QStringList>
#include <QElapsedTimer>

int main(int argc, char *argv[])
{
    typedef std::vector<double> Vector3;
    std::vector<Vector3> pnts;
	if(argc < 2) return 0;

    QFile file( argv[1] );
    if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) return 0;

    QTextStream inF(&file);
    while( !inF.atEnd() ){
        QString line = inF.readLine();
        if(!line.size()) continue;
        Vector3 p;
        foreach(QString coord, line.split(" ", QString::SkipEmptyParts)) p.push_back(coord.toDouble());
        pnts.push_back(p);
    }

	//QElapsedTimer timer; timer.start();

	{
		MinOBB::OBB<Vector3> bb(pnts);

		// Output fit to standard out
		double * a = bb.minimum();
		double * b = bb.maximum();
		std::vector<double> q = bb.rotation();

		std::cout << qPrintable( QString("%1 %2 %3\n").arg(a[0]).arg(a[1]).arg(a[2]) );
		std::cout << qPrintable( QString("%1 %2 %3\n").arg(b[0]).arg(b[1]).arg(b[2]) );
		std::cout << qPrintable( QString("%1 %2 %3 %4\n").arg(q[0]).arg(q[1]).arg(q[2]).arg(q[3]) );
	}

	//printf("%d ms", timer.elapsed());

    return 0;
}

